<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework;

class Pla06600GetServico extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName = 'pla06600_getservico';
    protected $crudService;
    protected $dataSourceManager;
    protected $parameterBagColumns = array(
        'P_CDFILIAL',
        'P_IDTIPOSERV',
        'P_CDGRUPSERV',
        'P_TGRUP',
        'P_DTMESCARD',
        'P_NRORG'
    );
    public function __construct($crudService, $parameterBag, $dataSourceManager) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
    }

    public function find(Framework\DTO\Request\Filter $request, Framework\DTO\Response $response) {
    	
    	try {
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
    		$newDataSet = $this->buildDescriptionValue($dataSet->getRows());
    		$response->addDataSet(new Framework\DataSource\DataSet ('pla06600_getservico', $newDataSet));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function buildDescriptionValue($rows) {
    	foreach ($rows as $key => $value) {
    		$rows[$key]['DSSERVICO'] = $rows[$key]['CDFILIAL'].' - '.$rows[$key]['CDSERVFILI'].' '.$rows[$key]['NMSERVICO'];
    	}
    	return $rows;
    }
}
