<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use \Zeedhi\Framework\DB\StoredProcedure\Param;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DTO\Request\DataSet;
use Zeedhi\Framework\DataSource;

class Pla19000PainelProducaoController {
    protected $environment;
	protected $entityManager;
    protected $connection;
    protected $novoCodigo;

    public function __construct($environment, $entityManager, $connection, $novoCodigo) {
        //$this->crudService = $crudService;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->connection = $connection;
        $this->novoCodigo = $novoCodigo;
    }
    
    public function salvaStatusPrato(\Zeedhi\Framework\DTO\Request $request, \Zeedhi\Framework\DTO\Response $response){
        try{
            $this->connection->beginTransaction();
            $row = $request->getRow();
            
            $paramHora = 'INIPREPREAL';
            if($row['IDSTATUS'] == 'C') $paramHora = 'FIMPREPREAL';
            
            $horaSave = $this->horaToFloat($row['TEMPOPREPREAL']);
            $sql = "UPDATE PRODCADENCI SET ".$paramHora." = :".$paramHora.", IDSTATUS = :IDSTATUS WHERE NRPRODCADENCI = :NRPRODCADENCI";
            $params = array(
                $paramHora   => $horaSave,
                'IDSTATUS' => $row['IDSTATUS'],
                'NRPRODCADENCI' => $row['NRPRODCADENCI']
            );
            
            $this->connection->executeUpdate($sql, $params);
            $this->connection->commit();
        }catch (\Exception $e) {
            $this->connection->rollback();
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
    
    private function horaToFloat ($horas){
        $result = 0;
        $hora = substr($horas, 0, strrpos($horas, ":"));
        $min = substr($horas, strrpos($horas, ":")+ 1, strlen($horas));
        $result = floatval($hora) + (floatval($min)/60);
        return round($result, 6);
    }
}